import { Address, ContractState, TestContractResult, HexString, ContractFactory, SubscribeOptions, EventSubscription, CallContractParams, CallContractResult, TestContractParams, ContractCreatedEvent, ContractDestroyedEvent, ContractInstance } from "@alephium/web3";
export declare namespace TestTokenTypes {
    type Fields = {
        symbol: HexString;
        name: HexString;
        decimals: bigint;
        totalSupply: bigint;
    };
    type State = ContractState<Fields>;
}
declare class Factory extends ContractFactory<TestTokenInstance, TestTokenTypes.Fields> {
    at(address: string): TestTokenInstance;
    testGetSymbolMethod(params: Omit<TestContractParams<TestTokenTypes.Fields, never>, "testArgs">): Promise<TestContractResult<HexString>>;
    testGetNameMethod(params: Omit<TestContractParams<TestTokenTypes.Fields, never>, "testArgs">): Promise<TestContractResult<HexString>>;
    testGetDecimalsMethod(params: Omit<TestContractParams<TestTokenTypes.Fields, never>, "testArgs">): Promise<TestContractResult<bigint>>;
    testGetTotalSupplyMethod(params: Omit<TestContractParams<TestTokenTypes.Fields, never>, "testArgs">): Promise<TestContractResult<bigint>>;
    testBuyMethod(params: TestContractParams<TestTokenTypes.Fields, {
        from: HexString;
        amount: bigint;
        factor: bigint;
    }>): Promise<TestContractResult<null>>;
}
export declare const TestToken: Factory;
export declare class TestTokenInstance extends ContractInstance {
    constructor(address: Address);
    fetchState(): Promise<TestTokenTypes.State>;
    subscribeContractCreatedEvent(options: SubscribeOptions<ContractCreatedEvent>, fromCount?: number): EventSubscription;
    subscribeContractDestroyedEvent(options: SubscribeOptions<ContractDestroyedEvent>, fromCount?: number): EventSubscription;
    subscribeAllEvents(options: SubscribeOptions<ContractCreatedEvent | ContractDestroyedEvent>, fromCount?: number): EventSubscription;
    callGetSymbolMethod(params?: Omit<CallContractParams<{}>, "args">): Promise<CallContractResult<HexString>>;
    callGetNameMethod(params?: Omit<CallContractParams<{}>, "args">): Promise<CallContractResult<HexString>>;
    callGetDecimalsMethod(params?: Omit<CallContractParams<{}>, "args">): Promise<CallContractResult<bigint>>;
    callGetTotalSupplyMethod(params?: Omit<CallContractParams<{}>, "args">): Promise<CallContractResult<bigint>>;
}
export {};
